/*
 * Copyright (C) 2004   Derrick Moser
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#include "Buffer.h"

#include <stdlib.h>
#include <string.h>

Buffer::Buffer() : m_buffer(0), m_buffer_count(0), m_buffer_max(0)
{
}

Buffer::~Buffer()
{
  clear();
}


bool Buffer::append(int c)
{
  if(m_buffer_count + 1 > m_buffer_max)
  {
    int s = 2 * (m_buffer_count + 1);
    int *b = (int *)realloc(m_buffer, s * sizeof(int));
    if(!b)
      return false;
    m_buffer = b;
    m_buffer_max = s;
  }

  m_buffer[m_buffer_count++] = c;
  return true;
}

void Buffer::removeFirst(int n)
{
  if(n > 0 && n <= m_buffer_count)
  {
    m_buffer_count -= n;
    if(m_buffer_count)
      memmove(m_buffer, &m_buffer[n], m_buffer_count * sizeof(int));
  }
}

void Buffer::removeLast(int n)
{
  if(n > 0 && n <= m_buffer_count)
    m_buffer_count -= n;
}

void Buffer::clear()
{
  if(m_buffer)
  {
    free(m_buffer);
    m_buffer = 0;
    m_buffer_count = 0;
    m_buffer_max = 0;
  }
}
