/*
 * Copyright (C) 2004   Derrick Moser
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#ifndef Composer_h_included
#define Composer_h_included

#include "SyllableParser.h"
#include "Buffer.h"

class Composer
{
protected:
  SyllableParser m_parser;

  Buffer m_output;
  Buffer m_input;

  bool parse(bool force);

public:
  bool isEmpty() const;
  void clear();
  bool append(int c);
  void backspace();
  bool accept();
  bool convert();
};

#endif // Composer_h_included
