/*
 * Copyright (C) 2004   Derrick Moser
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#ifndef Parser_h_included
#define Parser_h_included

enum
{
  Success,
  Incomplete,
  Failed
};

struct Pattern
{
  const char *m_pattern;
  int m_result;
};

class Parser
{
  int m_npatterns;
  Pattern *m_patterns;

  int m_length;
  int m_result;

public:
  Parser(int npatterns, Pattern *patterns);

  int parse(const int *s, int len, int max_pattern, bool force);

  int getLength() const { return m_length; }
  int getResult() const { return m_result; }
};

#endif // Parser_h_included
