/*
 * Copyright (C) 2004   Derrick Moser
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#ifndef SyllableParser_h_included
#define SyllableParser_h_included

#include "Parser.h"

class SyllableParser
{
  Parser m_part1;
  Parser m_part2;
  Parser m_part3;
  Parser m_partial;

  int m_length;
  int m_result;

public:
  SyllableParser();
  ~SyllableParser();

  int parse(const int *s, int len, bool force);

  int getLength() const { return m_length; }
  int getResult() const { return m_result; }
};

#endif // SyllableParser_h_included
